public class LIDAR
{
double[][] referenz = new double[360][2];  
double[][] distanz_alter = new double[360][2];  //Index0: DISTANZ, Index1: Letzter Update in ms (Systemzeit)
char[] PUFFER = new char[200];
char[] PUFFER2 = new char[200];
int INX=0;

long MAX_ALTER = 3000; //Maximal erlaubtes Alter einer Messung in Millisekunden


String dist;        // Data received from the serial port´
String val;

int angle;
int distance;
//int i = angle;

  
  public void merken()
  {
       for(int i=0;i<referenz.length;i++)
           for(int k=0;k<referenz[i].length;k++)
                referenz[i][k] = distanz_alter[i][k];
                
       speichern("test.txt",referenz);
       laden("test.txt");                
  }
  
  public double berechneAbstand()
  {
       double dist = 0.0;
       for(int i=0;i<referenz.length;i++)
       {
            int i2 = (i+1)%distanz_alter.length;
            int i3 = (i-1+distanz_alter.length)%distanz_alter.length;
            double d1 = (referenz[i][0]-distanz_alter[i][0])*(referenz[i][0]-distanz_alter[i][0]);
            double d2 = (referenz[i][0]-distanz_alter[i2][0])*(referenz[i][0]-distanz_alter[i2][0]);
            double d3 = (referenz[i][0]-distanz_alter[i3][0])*(referenz[i][0]-distanz_alter[i3][0]);
            
            double d = d1;
            if(d2<d) d=d2;
            if(d3<d) d=d3;
            dist+=d;
       }
       return Math.sqrt(dist);
  }

  public double berechneAbstandMIN()
  {
    double ddd = Double.MAX_VALUE;
    for(int offset=0;offset<360;offset++)
    {
       double dist = 0.0;
       for(int i=0;i<referenz.length;i++)
       {
            int i2 = (i+1)%distanz_alter.length;
            int i3 = (i-1+distanz_alter.length)%distanz_alter.length;
            int ii = (i+offset)%referenz.length;
            double d1 = (referenz[ii][0]-distanz_alter[i][0])*(referenz[ii][0]-distanz_alter[i][0]);
            double d2 = (referenz[ii][0]-distanz_alter[i2][0])*(referenz[ii][0]-distanz_alter[i2][0]);
            double d3 = (referenz[ii][0]-distanz_alter[i3][0])*(referenz[ii][0]-distanz_alter[i3][0]);
            
            double d = d1;
            if(d2<d) d=d2;
            if(d3<d) d=d3;
            dist+=d;
       }
       
       if(dist<ddd)
           ddd=dist;
    }    
       return Math.sqrt(ddd);
  }
  
  
  public double[] holeDistanzen()
  {
       double[] dist = new double[distanz_alter.length];
       for(int i=0;i<dist.length;i++)
           dist[i] = distanz_alter[i][0];
           
       return dist;    
  }
  
  public LIDAR(PApplet pap,Serial myPort)
  {
  for(int i=0;i<PUFFER.length;i++)
  {
        PUFFER[i] = ' ';
        PUFFER2[i] = ' ';
  }
    
  long STARTZEIT = System.currentTimeMillis();
  for(int i=0;i<distanz_alter.length;i++)
     distanz_alter[i][1] = (double)STARTZEIT;
    
      String portName = Serial.list()[0];
      myPort = new Serial(pap, portName, 115200);
    
  }
  
  public void draw()
  {
  lidar.drawTemplate();
  drawline();

  fill(0);
  textSize(20);
  
  double aeltester = Double.MAX_VALUE;
  int INDEX = 0;
  for(int i=0;i<distanz_alter.length;i++)
     if(distanz_alter[i][1]<aeltester)
     {
         aeltester = distanz_alter[i][1];
         INDEX=i;
     }
  text("Ältester: "+(System.currentTimeMillis() - (long)aeltester)+" INDEX="+INDEX,20,80);

  text("DIST="+berechneAbstand(),20,150);  
  text("DIST_MIN="+berechneAbstandMIN(),20,180);  
  }
  
  public void drawTemplate()
  {
    background(255);
    stroke(0);
    noFill();
    for (int i = 1; i <= 7; i++)
    {
        ellipse(width/2, height/2, i*130, i*130);
    }
    strokeWeight(3);
    line(width/2,0,width/2,height);
    line(0,height/2,width,height/2);
  
    fill (0);
    textSize(18);
    text("3500",width/2 + 5, height/2 - 460);
    text("3000",width/2 + 5, height/2 - 395);
    text("2500",width/2 + 5, height/2 - 330);
    text("2000",width/2 + 5, height/2 - 265);
    text("1500",width/2 + 5, height/2 - 200);
    text("1000",width/2 + 5, height/2 - 135);
    text("500",width/2 + 5, height/2 - 70);
  }
  
  
 void drawline()
 {

  for (int i = 0; i < distanz_alter.length; i++)

  {
    boolean OK = true;
//    if(System.currentTimeMillis()-(long)distanz_alter[i][1]>MAX_ALTER)
//        OK = false;
    
    float angle = i;
    float distance = (float)distanz_alter[i][0];
    
    if(OK == false)
    {
        distance = 3500.0;
        stroke(100,255,100);
        println("ERROR BEI "+i);
    }
    else
    {
        stroke(0);
    }
    
    float x0 = width/2;
    float y0 = height/2;
    float xi = (width/2 + cos(radians(-1.0*angle)-PI/2)*(distance/8.0)*1.0);
    float yi = (height/2 + sin(radians(-1.0*angle)-PI/2)*(distance/8.0)*1.0);
 
 
 
    strokeWeight(1);
    line(x0, y0, xi, yi);
    //println("xi",+xi);
    //println("yi",+yi);
    //println();
    
  }

  
 }
 
 
 
  void serialEventLIDAR(Serial myPort) 
  {
    //put the incoming data into a String - 
    //the '\n' is our end delimiter indicating the end of a complete packet
  
    //val = myPort.readStringUntil('\n');
    //println(val);
  
    int c = myPort.read();
  
    PUFFER[INX] = (char)c;
    INX++;
    INX%=PUFFER.length;
    val = null;
    if(c=='\n')
    {
          for(int i=0;i<PUFFER.length;i++)
          {
               PUFFER2[i] = PUFFER[(INX+i)%PUFFER.length];            
          }
          val = new String(PUFFER2);
          
          for(int i=0;i<PUFFER.length;i++)
              PUFFER[i] = ' ';
          
    }
  
    if(val!=null)
    {
       String[] dist = splitTokens(val, ", ");
       //println(dist[0]);  // Prints "a"
       //println(dist[1]);  // Prints "b"
       //println(dist[2]);  // Prints "c"
       //println(dist[3]);  // Prints "d"
  
       if(dist!=null && dist.length==4)
       {
          angle = Integer.parseInt(dist[1]);
          distance = Integer.parseInt(dist[2]);
    
          if(angle>=0 && angle<=359 && distance>=0)
          {
              distanz_alter[angle][0] = (double)distance;
              distanz_alter[angle][1] = (double)System.currentTimeMillis();
          }
          //println("Angle=",+angle);
          //println("Distance=",+distance);
          //println(angle + distance);
       }
    }
  }
 
}